unit unWarp;

  {
   TRABALHO T1 DE COMPUTAO GRFICA

   Professor: Marcio Pinho
   Turma: 138
   Alunos: Alexandre Souza Perucia
           Leonardo Sewald Cunha

   Descrio: Programa que executa o efeito Warp em imagens
   BitMaps.

   Inicio do Desenvolvimento: 19/05
   Ultima Atualizao: 02/06
   Termino Previsto: 02/06
  }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtDlgs, Buttons, ToolWin, ComCtrls, StdCtrls, ExtCtrls;

type
  //Definicao da posicao de um ponto
  StructPonto = record
    x, y: integer;
  end;
  //Definicao de um retangulo e seus
  StructRet = record
    pInicial: StructPonto;
    pFinal  : StructPonto;
    pMedio_esq, pMedio_dir,
    pMedio_cima, pMedio_baixo, pMedio_centro, pCentral_fixo: StructPonto;
  end;

  //Definicao de um triangulo
  StructTriangulo = array[0..2] of StructPonto;

  TfmImageWarp = class(TForm)
    opAbrir: TOpenPictureDialog;
    bbAbrir: TBitBtn;
    bbSair: TBitBtn;
    bbLimpar: TBitBtn;
    ScrollBox2: TScrollBox;
    Label2: TLabel;
    bbWarp: TBitBtn;
    imFinal: TImage;
    Label3: TLabel;
    Label4: TLabel;
    Label1: TLabel;
    ScrollBox1: TScrollBox;
    imWarp: TImage;
    sbStatus: TStatusBar;
    procedure imWarpMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imWarpMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bbAbrirClick(Sender: TObject);
    procedure bbSairClick(Sender: TObject);
    procedure bbLimparClick(Sender: TObject);
    procedure bbWarpClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure imWarpMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    //Essa funcao verifica se o maouse esta em cima dos pontos
    //Tolerancia eh o erro em relacao ao ponto correto
    function fVerificaSuperficie(X, Y: integer; tolerancia: byte): boolean;
    function ViolaPontosMedios(X, Y: integer): boolean;
    //Rotina que testa se um ponto esta ou nao dentro de um triangulo
    function PontoEmTriangulo(T:StructTriangulo; N:integer; P:StructPonto): boolean;
    //Rotina que testa se o ponto medio central esta na area permitida
    function TestaConcavidade(p:StructPonto):boolean;

    //Rotinas para executar o warp em cada quadro
    //Na ordem: Horizontal - Vertical
    //superior esquerdo, inferior esquerdo
    //superior direito, inferior direito
    procedure Warp(xi, yi, xf, yf, xd: integer);
    procedure Warp2(xi, yi, xf, yf, xd: integer);
    procedure Warp3(xi, yi, xf, yf, xd: integer);
    procedure Warp4(xi, yi, xf, yf, xd: integer);

    procedure Warpv(xi, yi, xf, yf, yd: integer);
    procedure Warp2v(xi, yi, xf, yf, yd: integer);
    procedure Warp3v(xi, yi, xf, yf, yd: integer);
    procedure Warp4v(xi, yi, xf, yf, yd: integer);
  end;
var
  fmImageWarp: TfmImageWarp;
  //Declaracao do retangulo warp
  RetWarp                     : StructRet; //Estrutura de pontos
  bolMalhaCriada, bolMouseDown: boolean;   //Flags
  ImgBuf, ImgBuf2             : TBitMap;   //Buffer de reduperacao
  Area                        : TRect;     //Area de recuperacao
implementation

{$R *.DFM}

//********************************************************
// ** Inicio das rotinas de Warp
//********************************************************
//Rotina para executar o warp horizontal no quadro superior esquerdo
procedure TfmImageWarp.Warp(xi, yi, xf, yf, xd: integer);
var
  passox, razao_pixels, acum_x: real;
  entrada, x, y: integer; //sendo x para linha e y para a coluna
begin
  //Para cada y temos tantos x percorridos a mais
  passox := (xd - xf)/(yf - yi);
  //So para tirar warning
  razao_pixels := 0;
  //Realizar o mapeamento inverso
  entrada := (xf - xi);
  acum_x := 0;
  for y := yi to yf do begin
    //A cada linha se recalcula a razao de pixels entre a entrada e a saida
    if ((entrada + ((y - yi) * passox)) > 0) then
      razao_pixels := entrada / (entrada + ((y - yi) * passox));
    //Percorre a linha y
    for x := xi to Round(xf + acum_x) do begin
      //Ajusta a posicao correta na imagem de entrada para definir a cor na saida
      imgBuf2.Canvas.Pixels[x, y] := imgBuf.Canvas.Pixels[Trunc(xi + (x - xi) * razao_pixels), y];
    end;
    //Incrementa novo passo
    acum_x := acum_x + passox;
  end;
end;



//Rotina para executar o warp horizontal no quadro inferior esquerdo
procedure TfmImageWarp.Warp2(xi, yi, xf, yf, xd: integer);
var
  passox, razao_pixels, acum_x: real;
  entrada, x, y: integer; //sendo x para linha e y para a coluna
begin
  //Para cada y temos tantos x percorridos a mais
  passox := (xd - xf)/(yf - yi);
  //So para tirar warning
  razao_pixels := 0;
  //Realizar o mapeamento inverso
  entrada := (xf - xi);
  acum_x := 0;
  for y := yi to yf do begin
    //A cada linha se recalcula a razao de pixels entre a entrada e a saida
    if ((entrada + ((y - yi) * passox)) <> 0) then
      razao_pixels := entrada / (entrada + ((y - yi) * passox));
    //Percorre a linha y
    for x := xi downto Round(xf + acum_x) do begin
      //Ajusta a posicao correta na imagem de entrada para definir a cor na saida
      imgBuf2.Canvas.Pixels[x, y] := imgBuf.Canvas.Pixels[Trunc(xi + (x - xi) * razao_pixels), y];
    end;
    //Incrementa novo passo
    acum_x := acum_x + passox;
  end;
end;



//Rotina para executar o warp horizontal no quadro superior direito
procedure TfmImageWarp.Warp3(xi, yi, xf, yf, xd: integer);
var
  passox, razao_pixels, acum_x: real;
  entrada, x, y: integer; //sendo x para linha e y para a coluna
begin
  //Para cada y temos tantos x percorridos a mais
  passox := (xf - xd)/(yf - yi);
  //So para tirar warning
  razao_pixels := 0;
  //Realizar o mapeamento inverso
  entrada := (xi - xf);
  acum_x := 0;
  for y := yi downto yf do begin
    //A cada linha se recalcula a razao de pixels entre a entrada e a saida
    if ((entrada + ((y - yi) * passox)) <> 0) then
      razao_pixels := entrada / (entrada + ((y - yi) * passox));
    //Percorre a linha y
    for x := xi to Round(xf + acum_x) do begin
      //Ajusta a posicao correta na imagem de entrada para definir a cor na saida
      imgBuf2.Canvas.Pixels[x, y] := imgBuf.Canvas.Pixels[Trunc(xi + (x - xi) * razao_pixels), y];
    end;
    //Incrementa novo passo
    acum_x := acum_x + passox;
  end;
end;


//Rotina para executar o warp horizontal no quadro inferior direito
procedure TfmImageWarp.Warp4(xi, yi, xf, yf, xd: integer);
var
  passox, razao_pixels, acum_x: real;
  entrada, x, y: integer; //sendo x para linha e y para a coluna
begin
  //Para cada y temos tantos x percorridos a mais
  passox := (xf - xd)/(yf - yi);
  //So para tirar warning
  razao_pixels := 0;
  //Realizar o mapeamento inverso
  entrada := (xi - xf);
  acum_x := 0;
  for y := yi downto yf do begin
    //A cada linha se recalcula a razao de pixels entre a entrada e a saida
    if ((entrada + ((y - yi) * passox)) <> 0) then
      razao_pixels := entrada / (entrada + ((y - yi) * passox));
    //Percorre a linha y
    for x := xi downto Round(xf + acum_x) do begin
      //Ajusta a posicao correta na imagem de entrada para definir a cor na saida
      imgBuf2.Canvas.Pixels[x, y] := imgBuf.Canvas.Pixels[Trunc(xi + (x - xi) * razao_pixels), y];
    end;
    //Incrementa novo passo
    acum_x := acum_x + passox;
  end;
end;


//Rotina para executar o warp vertical no quadro superior esquerdo
procedure TfmImageWarp.Warpv(xi, yi, xf, yf, yd: integer);
var
  passoy, razao_pixels, acum_y: real;
  entrada, x, y: integer; //sendo x para linha e y para a coluna
begin
  razao_pixels := 0; //So pra tirar warning :)
  //Para cada x temos tantos y percorridos a mais
  passoy := (yd - yf)/(xf - xi); //Para cada x anda pass0y ys
  entrada := (yf - yi);
  acum_y := 0;
  for x := xi to (xf - 1) do begin
    //A cada coluna se recalcula a razao de pixels entre a entrada e a saida
    if ((entrada + ((x - xi) * passoy)) <> 0) then
      razao_pixels := entrada / (entrada + ((x - xi) * passoy));
    for y := yi to Round(yf + acum_y) do begin
      //Ajusta a posicao correta na imagem de entrada para definir a cor na saida
      imFinal.Canvas.Pixels[x, y] := imgBuf2.Canvas.Pixels[x, Trunc(yi + ((y - yi) * razao_pixels))];
    end;
    //Incrementa novo passo
    acum_y := acum_y + passoy;
  end;
end;


//Rotina para executar o warp vertical no quadro inferior esquerdo
procedure TfmImageWarp.Warp2v(xi, yi, xf, yf, yd: integer);
var
  passoy, razao_pixels, acum_y: real;
  entrada, x, y: integer; //sendo x para linha e y para a coluna
begin
  razao_pixels := 0; //So pra tirar warning :)
  //Para cada x temos tantos y percorridos a mais
  passoy := (yd - yf)/(xf - xi);
  //Realizar o mapeamento inverso
  entrada := yf - yi;
  acum_y := 0;
  for x := xi to xf  do begin
    if((entrada + ((x-xi) * passoy))<>0) then
      razao_pixels := entrada / (entrada + ((x - xi)* passoy));
    for y := yi downto Round(yf + acum_y) do begin
      //Ajusta a posicao correta na imagem de entrada para definir a cor na saida
      imFinal.Canvas.Pixels[x, y] := imgBuf2.Canvas.Pixels[x, Trunc(yi + ((y - yi) * razao_pixels))];
    end;
    //Incrementa novo passo
    acum_y := acum_y + passoy;
  end;
end;

//Rotina para executar o warp vertical no quadro superior direito
procedure TfmImageWarp.Warp3v(xi, yi, xf, yf, yd: integer);
var
  passoy, razao_pixels, acum_y: real;
  entrada, x, y: integer; //sendo x para linha e y para a coluna
begin
  razao_pixels := 0; //So pra tirar warning :)
  //Para cada x temos tantos y percorridos a mais
  passoy := (yd - yf)/(xf - xi); //Para cada x anda pass0y ys
  entrada := (yf - yi);
  acum_y := 0;
  for x := xf downto (xi) do begin
    //A cada coluna se recalcula a razao de pixels entre a entrada e a saida
    if ((entrada + (abs(x - xf) * passoy)) <> 0) then
      razao_pixels := entrada / (entrada + (abs(x - xf) * passoy));
    for y := yi to Round(yf + acum_y) do begin
      //Ajusta a posicao correta na imagem de entrada para definir a cor na saida
      imFinal.Canvas.Pixels[x, y] := imgBuf2.Canvas.Pixels[x, Trunc(yi + ((y - yi) * razao_pixels))];
    end;
    //Incrementa novo passo
    acum_y := acum_y + passoy;
  end;
end;


//Rotina para executar o warp vertical no quadro inferior direito
procedure TfmImageWarp.Warp4v(xi, yi, xf, yf, yd: integer);
var
  passoy, razao_pixels, acum_y: real;
  entrada, x, y: integer; //sendo x para linha e y para a coluna
begin
  razao_pixels := 0; //So pra tirar warning :)
  //Para cada x temos tantos y percorridos a mais
  passoy := (yd - yf)/(xf - xi);      //x eh positivo
  //Realizar o mapeamento inverso
  entrada := yf - yi;   //positivo
  acum_y := 0;
  for x := xi downto xf  do begin
    if((entrada + ((x-xi) * passoy))<>0) then
      razao_pixels := entrada / (entrada + ((x - xi)* passoy));
    for y := yi downto Round(yf - acum_y) do begin
      //Ajusta a posicao correta na imagem de entrada para definir a cor na saida
      imFinal.Canvas.Pixels[x, y] := imgBuf2.Canvas.Pixels[x, Trunc(yi + ((y - yi) * razao_pixels))];
    end;
    //Incrementa novo passo
    acum_y := acum_y + passoy;
  end;
end;

//***********************************************************
//Fim das rotinas de Warp
//***********************************************************




//Verifica se o mouse esta em cima do ponto
function TfmImageWarp.fVerificaSuperficie(X, Y: integer; tolerancia: byte): boolean;
begin
  result := false;
  if ((X >= (RetWarp.pMedio_centro.x - tolerancia)) and
      (X <= (RetWarp.pMedio_centro.x + tolerancia))) then
    if ((Y >= (RetWarp.pMedio_centro.y - tolerancia)) and
      (Y <= (RetWarp.pMedio_centro.y + tolerancia))) then
      result := true;
end;

//Verifica se o ponto central nao viola os pontos medios
//da malha
function TfmImageWarp.ViolaPontosMedios(X, Y: integer): boolean;
begin
  result := false;
  //Ver se o ponto nao passa dos extremos
  if ((x <= RetWarp.pInicial.x) or (x >= RetWarp.pFinal.x) or (y >= RetWarp.pFinal.y) or (y <= RetWarp.pInicial.y)) then
    result := true;
end;

function minimo(x, y:integer):integer;
begin
  if(x<y) then
    result := x
  else
    result := y;
end;

function maximo(x, y:integer):integer;
begin
  if(x>y) then
    result := x
  else
    result := y;
end;

function TfmImageWarp.PontoEmTriangulo(T:StructTriangulo; N:integer; P:StructPonto): boolean;
var
  cont, i:integer;
  xinters:real;
  p1, p2:StructPonto;
begin
  cont := 0;
  //xinters := 0;
  p1 := T[0];
  for i := 1 to N do
  begin
    p2 := T[i mod N];
    if (P.y > minimo(p1.y, p2.y)) then begin
      if(P.y <= maximo(p1.y, p2.y)) then begin
        if(P.x <=maximo(p1.x, p2.x)) then begin
          if(p1.y <> p2.y) then begin
            xinters := (p.y-p1.y)*(p2.x-p1.x)/(p2.y-p1.y)+p1.x;
            if (p1.x = p2.x) or (p.x <= xinters) then
              cont := cont + 1;
          end;
        end;
      end;
    end;
    p1 := p2;
  end;
  if (cont mod 2 = 0) then
    result := false
  else
    result := true;
end;

function TfmImageWarp.TestaConcavidade(p:StructPonto):boolean;
var
  tri:StructTriangulo;
begin
  result := false;
  //Triangulo superior esquerdo
  tri[0] := RetWarp.pInicial;
  tri[1] := RetWarp.pMedio_cima;
  tri[2] := RetWarp.pMedio_esq;

  if(PontoEmTriangulo(tri, 3, p)) then
  begin
    result := true;
    exit;
  end;

    //Triangulo superior direito
  tri[0] := RetWarp.pMedio_Cima;
  tri[1] := RetWarp.pMedio_dir;
  tri[2].x := RetWarp.pFinal.x;
  tri[2].y := RetWarp.pInicial.y;

  if(PontoEmTriangulo(tri, 3, p)) then
  begin
    result := true;
    exit;
  end;

    //Triangulo inferior esquerdo
  tri[0] := RetWarp.pMedio_esq;
  tri[1] := RetWarp.pMedio_baixo;
  tri[2].x := RetWarp.pInicial.x;
  tri[2].y := RetWarp.pFinal.y;

  if(PontoEmTriangulo(tri, 3, p)) then
  begin
    result := true;
    exit;
  end;

    //Triangulo inferior direito
  tri[0] := RetWarp.pMedio_baixo;
  tri[1] := RetWarp.pMedio_dir;
  tri[2] := RetWarp.pFinal;

  if(PontoEmTriangulo(tri, 3, p)) then
  begin
    result := true;
    exit;
  end;
end;


//**************************************************
// ** Tratamento dos eventos
//**************************************************

procedure TfmImageWarp.imWarpMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  //Se a malha ainda nao foi criada entao esse eh o ponto inicial
  if (not bolMalhaCriada) then begin
    imWarp.Canvas.CopyRect(Area, ImgBuf.Canvas, Area);
    RetWarp.pInicial.x := X;
    RetWarp.pInicial.y := Y;
    imWarp.Canvas.MoveTo(RetWarp.pInicial.x, RetWarp.pInicial.y);
  end;
  //Seta mouse pressionado
  bolMouseDown := True;
end;

procedure TfmImageWarp.imWarpMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //No momento que o botao do mouse eh solto desativa o flag
  bolMouseDown := False;
  //Se a malha ainda nao foi criada entao define ela agora
  if ((not bolMalhaCriada)) then begin
    RetWarp.pFinal.x := X;
    RetWarp.pFinal.y := Y;
    imWarp.Canvas.Pen.Style := psSolid;
    imWarp.Canvas.Rectangle(RetWarp.pInicial.x, RetWarp.pInicial.y, RetWarp.pFinal.x, RetWarp.pFinal.y);

    //Calcula o ponto medio central
    RetWarp.pMedio_centro.x := ((RetWarp.pFinal.x - RetWarp.pInicial.x) div 2) + RetWarp.pInicial.x;
    RetWarp.pMedio_centro.y := ((RetWarp.pFinal.y - RetWarp.pInicial.y) div 2) + RetWarp.pInicial.y;
    //Determinar o ponto central fixo => Esse valor nao muda
    RetWarp.pCentral_fixo := RetWarp.pMedio_centro;

    //Esses valores serao fixos
    RetWarp.pMedio_esq.x := RetWarp.pInicial.x;
    RetWarp.pMedio_esq.y := RetWarp.pMedio_centro.y;
    RetWarp.pMedio_dir.x := RetWarp.pFinal.x;
    RetWarp.pMedio_dir.y := RetWarp.pMedio_centro.y;
    RetWarp.pMedio_cima.x := RetWarp.pMedio_centro.x;
    RetWarp.pMedio_cima.y := RetWarp.pInicial.y;
    RetWarp.pMedio_baixo.x := RetWarp.pMedio_centro.x;
    RetWarp.pMedio_baixo.y := RetWarp.pFinal.y;

    //Desenha a malha
    label4.Caption := 'Ponto: ('+IntToStr(RetWarp.pMedio_centro.x)+','+IntToStr(RetWarp.pMedio_centro.y)+')';
    imWarp.Canvas.MoveTo(RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);
    imWarp.Canvas.LineTo((abs(RetWarp.pFinal.x-RetWarp.pInicial.x) div 2)+RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);
    imWarp.Canvas.MoveTo(RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);
    imWarp.Canvas.LineTo(RetWarp.pMedio_centro.x, (abs(RetWarp.pFinal.y-RetWarp.pInicial.y) div 2)+RetWarp.pMedio_centro.y);

    imWarp.Canvas.MoveTo(RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);
    imWarp.Canvas.LineTo(-(abs(RetWarp.pFinal.x-RetWarp.pInicial.x) div 2)+RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);
    imWarp.Canvas.MoveTo(RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);
    imWarp.Canvas.LineTo(RetWarp.pMedio_centro.x, -(abs(RetWarp.pFinal.y-RetWarp.pInicial.y) div 2)+RetWarp.pMedio_centro.y);

    imWarp.Canvas.Pen.Width := 5;
    imWarp.Canvas.Pen.Color := clRed;
    imWarp.Canvas.Ellipse(RetWarp.pMedio_centro.x - 2, RetWarp.pMedio_centro.y - 2,
                        RetWarp.pMedio_centro.x + 2,RetWarp.pMedio_centro.y + 2);
    imWarp.Canvas.Ellipse(RetWarp.pMedio_esq.x - 2, RetWarp.pMedio_esq.y - 2,
                        RetWarp.pMedio_esq.x + 2,RetWarp.pMedio_esq.y + 2);
    imWarp.Canvas.Ellipse(RetWarp.pMedio_dir.x - 2, RetWarp.pMedio_dir.y - 2,
                        RetWarp.pMedio_dir.x + 2,RetWarp.pMedio_dir.y + 2);
    imWarp.Canvas.Ellipse(RetWarp.pMedio_cima.x - 2, RetWarp.pMedio_cima.y - 2,
                        RetWarp.pMedio_cima.x + 2,RetWarp.pMedio_cima.y + 2);
    imWarp.Canvas.Ellipse(RetWarp.pMedio_baixo.x - 2, RetWarp.pMedio_baixo.y - 2,
                        RetWarp.pMedio_baixo.x + 2,RetWarp.pMedio_baixo.y + 2);
    imWarp.Canvas.Pen.Color := clLime;
    imWarp.Canvas.Pen.Width := 1;
    bolMalhaCriada := True;
    bbWarp.Enabled := True;
  end;
  //Testa para ver se o retangulo foi criado corretamente
  if ((X<RetWarp.pInicial.x) or (Y<RetWarp.pInicial.y)) then begin
    sbStatus.Panels[0].Text := 'Faca a selecao da esquerda p/ a direita, de cima para baixo.';
    imWarp.Canvas.CopyRect(Area, ImgBuf.Canvas, Area);
    bolMalhaCriada := False;
    bbWarp.Enabled := False;
  end;
end;


procedure TfmImageWarp.bbAbrirClick(Sender: TObject);
begin
  if (opAbrir.Execute) then begin
    imWarp.Picture.LoadFromFile(opAbrir.FileName);
    imWarp.Canvas.Brush.Style := bsClear;
    imWarp.Canvas.Pen.Width   := 1;
    imWarp.Canvas.Pen.Color   := clLime;
    imgBuf.Assign(imWarp.Picture.BitMap);
    Area.Left := 0;
    Area.Top := 0;
    Area.Right := imWarp.Picture.Width;
    Area.Bottom := imWarp.Picture.Height;
    bbLimpar.Enabled := True;
    bolMouseDown := False;
    bolMalhaCriada := False;
    bbWarp.Enabled := False;
    sbStatus.Panels[0].Text := 'Imagem aberta.';
  end;
end;

procedure TfmImageWarp.bbSairClick(Sender: TObject);
begin
  Close;
end;

procedure TfmImageWarp.bbLimparClick(Sender: TObject);
begin
  imWarp.Canvas.CopyRect(Area, ImgBuf.Canvas, Area);
  bolMalhaCriada := False;
  bbWarp.Enabled := False;
end;

procedure TfmImageWarp.bbWarpClick(Sender: TObject);
begin
  //imFinal.Canvas.CopyRect(Area, ImgBuf.Canvas, Area);
  imFinal.Picture.Bitmap.Assign(ImgBuf);
  imgBuf2.Assign(ImgBuf);


  //Tratamento de warp vertical (imFinal = ImgBuf2);

  sbStatus.Panels[0].Text := 'Processando quadro superior esquerdo (passagem vertical)...';
  Warpv(RetWarp.pInicial.x, RetWarp.pInicial.y, RetWarp.pCentral_Fixo.x, RetWarp.pMedio_esq.y, RetWarp.pMedio_Centro.y);
  Application.ProcessMessages;

  sbStatus.Panels[0].Text := 'Processando quadro inferior esquerdo (passagem vertical)...';
  Warp2v(RetWarp.pMedio_esq.x, RetWarp.pMedio_baixo.y, RetWarp.pMedio_baixo.x, RetWarp.pMedio_esq.y, RetWarp.pMedio_centro.y);
  Application.ProcessMessages;

  sbStatus.Panels[0].Text := 'Processando quadro superior direito (passagem vertical)...';
  Warp3v(RetWarp.pMedio_cima.x, RetWarp.pMedio_cima.y, RetWarp.pMedio_dir.x, RetWarp.pMedio_dir.y, RetWarp.pMedio_centro.y);
  Application.ProcessMessages;

  sbStatus.Panels[0].Text := 'Processando quadro inferior direito (passagem vertical)...';
  Warp4v(RetWarp.pMedio_dir.x, RetWarp.pMedio_baixo.y, RetWarp.pMedio_baixo.x, RetWarp.pMedio_dir.y, RetWarp.pMedio_centro.y);


  //new
  imgBuf.Assign(imFinal.Picture.Bitmap);

  //imgbuf2 = imgbuf

  sbStatus.Panels[0].Text := 'Processando quadro superior esquerdo (passagem horizontal)...';
  //Warp(RetWarp.pInicial.x, RetWarp.pInicial.y, RetWarp.pMedio_cima.x, RetWarp.pMedio_esq.y, RetWarp.pMedio_centro.x);
  Warp(RetWarp.pInicial.x, RetWarp.pInicial.y, RetWarp.pMedio_cima.x, RetWarp.pMedio_centro.y, RetWarp.pMedio_centro.x);
  imFinal.Canvas.CopyRect(Area, ImgBuf2.Canvas, Area);
  Application.ProcessMessages;

  sbStatus.Panels[0].Text := 'Processando quadro inferior esquerdo (passagem horizontal)...';
  //Warp2(RetWarp.pMedio_dir.x, RetWarp.pMedio_cima.y, RetWarp.pMedio_cima.x, RetWarp.pMedio_dir.y, RetWarp.pMedio_centro.x);
  Warp2(RetWarp.pMedio_dir.x, RetWarp.pMedio_cima.y, RetWarp.pMedio_cima.x, RetWarp.pMedio_centro.y, RetWarp.pMedio_centro.x);
  imFinal.Canvas.CopyRect(Area, ImgBuf2.Canvas, Area);
  Application.ProcessMessages;

  sbStatus.Panels[0].Text := 'Processando quadro superior direito (passagem horizontal)...';
  //Warp3(RetWarp.pMedio_esq.x, RetWarp.pMedio_baixo.y, RetWarp.pMedio_baixo.x, RetWarp.pMedio_esq.y, RetWarp.pMedio_Centro.x);
  Warp3(RetWarp.pMedio_esq.x, RetWarp.pMedio_baixo.y, RetWarp.pMedio_baixo.x, RetWarp.pMedio_centro.y, RetWarp.pMedio_Centro.x);
  imFinal.Canvas.CopyRect(Area, ImgBuf2.Canvas, Area);
  Application.ProcessMessages;

  sbStatus.Panels[0].Text := 'Processando quadro inferior direito (passagem horizontal)...';
  //Warp4(RetWarp.pMedio_dir.x, RetWarp.pMedio_baixo.y, RetWarp.pMedio_baixo.x, RetWarp.pMedio_dir.y, RetWarp.pMedio_Centro.x);
  Warp4(RetWarp.pMedio_dir.x, RetWarp.pMedio_baixo.y, RetWarp.pMedio_baixo.x, RetWarp.pMedio_centro.y, RetWarp.pMedio_Centro.x);
  //Copio a imagem transformada para o image buffer
  imFinal.Picture.Bitmap.Assign(ImgBuf2);
  imFinal.Canvas.CopyRect(Area, ImgBuf2.Canvas, Area);
  Application.ProcessMessages;
 

  //imgBuf.Assign(ImFinal.Picture.Bitmap);
  //imWarp.Picture.Bitmap.Assign(ImgBuf);
  imWarp.Picture.Bitmap.Assign(ImgBuf2);
  Application.ProcessMessages;
  bolMalhaCriada := False;
  sbStatus.Panels[0].Text := 'Warp Concludo.';
  bbWarp.Enabled := False;
  imgBuf.Assign(ImgBuf2);

  /////////
  //Redesenhar o retangulo e as bolinhas
          imWarp.Canvas.Pen.Color := clLime;
          imWarp.Canvas.Pen.Width := 1;
          imWarp.Canvas.Rectangle(RetWarp.pInicial.x, RetWarp.pInicial.y, RetWarp.pFinal.x, RetWarp.pFinal.y);

          //Puxar os pontos medios para os do centro
          imWarp.Canvas.MoveTo(RetWarp.pMedio_cima.x, RetWarp.pMedio_cima.y);
          imWarp.Canvas.LineTo(RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);
          imWarp.Canvas.MoveTo(RetWarp.pMedio_baixo.x, RetWarp.pMedio_baixo.y);
          imWarp.Canvas.LineTo(RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);

          imWarp.Canvas.MoveTo(RetWarp.pMedio_esq.x, RetWarp.pMedio_esq.y);
          imWarp.Canvas.LineTo(RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);
          imWarp.Canvas.MoveTo(RetWarp.pMedio_dir.x, RetWarp.pMedio_dir.y);
          imWarp.Canvas.LineTo(RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);

          //Desenhar as bolinha dos pontos medios
          imWarp.Canvas.Pen.Width := 5;
          imWarp.Canvas.Pen.Color := clRed;
          imWarp.Canvas.Ellipse(RetWarp.pMedio_centro.x - 2, RetWarp.pMedio_centro.y - 2,
                                RetWarp.pMedio_centro.x + 2,RetWarp.pMedio_centro.y + 2);
          imWarp.Canvas.Ellipse(RetWarp.pMedio_esq.x - 2, RetWarp.pMedio_esq.y - 2,
                                RetWarp.pMedio_esq.x + 2,RetWarp.pMedio_esq.y + 2);
          imWarp.Canvas.Ellipse(RetWarp.pMedio_dir.x - 2, RetWarp.pMedio_dir.y - 2,
                                RetWarp.pMedio_dir.x + 2,RetWarp.pMedio_dir.y + 2);
          imWarp.Canvas.Ellipse(RetWarp.pMedio_cima.x - 2, RetWarp.pMedio_cima.y - 2,
                                RetWarp.pMedio_cima.x + 2,RetWarp.pMedio_cima.y + 2);
          imWarp.Canvas.Ellipse(RetWarp.pMedio_baixo.x - 2, RetWarp.pMedio_baixo.y - 2,
                                RetWarp.pMedio_baixo.x + 2,RetWarp.pMedio_baixo.y + 2);
          imWarp.Canvas.Pen.Color := clLime;
          imWarp.Canvas.Pen.Width := 1;


end;

procedure TfmImageWarp.FormCreate(Sender: TObject);
begin
  ImgBuf := TBitMap.Create;
  ImgBuf2 := TBitmap.Create;
  bolMalhaCriada := False;
end;

procedure TfmImageWarp.FormDestroy(Sender: TObject);
begin
  ImgBuf.Free;
  ImgBuf2.Free;
end;

procedure TfmImageWarp.imWarpMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  ponto:StructPonto;
begin
  label3.Caption := 'Mouse: ('+IntToStr(X)+','+IntToStr(Y)+')';
  if (fVerificaSuperficie(X, Y, 4)) then
    Screen.Cursor := crHandPoint
  else Screen.Cursor := crDefault;

  if ((not bolMalhaCriada) and bolMouseDown) then begin
    imWarp.Canvas.Pen.Style := psDot;
    if ((X <= imWarp.Width) and (Y <= imWarp.Height) and (X >= imWarp.Left) and (Y >= imWarp.Top)) then begin
      imWarp.Canvas.CopyRect(Area, ImgBuf.Canvas, Area);
      imWarp.Canvas.Rectangle(RetWarp.pInicial.x, RetWarp.pInicial.y, X, Y);
    end;
  end;

  if (fVerificaSuperficie(X, Y, 4)) then begin
    if (bolMalhaCriada and bolMouseDown) then begin
      //Se a malha ja esta criada e o mouse pressionado
      if (not ViolaPontosMedios(X, Y)) then
      begin
        //e esta no centro entao atualiuza malha e centro
        Ponto.x := X;
        Ponto.y := Y;

        if(not TestaConcavidade(Ponto)) then
        begin
          //Restaura imagem
          imWarp.Canvas.CopyRect(Area, ImgBuf.Canvas, Area);

          //Atualiza o ponto medio central
          RetWarp.pMedio_centro.x := X;
          RetWarp.pMedio_centro.y := Y;
          label4.Caption := 'Ponto: ('+IntToStr(RetWarp.pMedio_centro.x)+','+IntToStr(RetWarp.pMedio_centro.y)+')';

          //Redesenhar o retangulo e as bolinhas
          imWarp.Canvas.Pen.Color := clLime;
          imWarp.Canvas.Pen.Width := 1;
          imWarp.Canvas.Rectangle(RetWarp.pInicial.x, RetWarp.pInicial.y, RetWarp.pFinal.x, RetWarp.pFinal.y);

          //Puxar os pontos medios para os do centro
          imWarp.Canvas.MoveTo(RetWarp.pMedio_cima.x, RetWarp.pMedio_cima.y);
          imWarp.Canvas.LineTo(RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);
          imWarp.Canvas.MoveTo(RetWarp.pMedio_baixo.x, RetWarp.pMedio_baixo.y);
          imWarp.Canvas.LineTo(RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);

          imWarp.Canvas.MoveTo(RetWarp.pMedio_esq.x, RetWarp.pMedio_esq.y);
          imWarp.Canvas.LineTo(RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);
          imWarp.Canvas.MoveTo(RetWarp.pMedio_dir.x, RetWarp.pMedio_dir.y);
          imWarp.Canvas.LineTo(RetWarp.pMedio_centro.x, RetWarp.pMedio_centro.y);

          //Desenhar as bolinha dos pontos medios
          imWarp.Canvas.Pen.Width := 5;
          imWarp.Canvas.Pen.Color := clRed;
          imWarp.Canvas.Ellipse(RetWarp.pMedio_centro.x - 2, RetWarp.pMedio_centro.y - 2,
                                RetWarp.pMedio_centro.x + 2,RetWarp.pMedio_centro.y + 2);
          imWarp.Canvas.Ellipse(RetWarp.pMedio_esq.x - 2, RetWarp.pMedio_esq.y - 2,
                                RetWarp.pMedio_esq.x + 2,RetWarp.pMedio_esq.y + 2);
          imWarp.Canvas.Ellipse(RetWarp.pMedio_dir.x - 2, RetWarp.pMedio_dir.y - 2,
                                RetWarp.pMedio_dir.x + 2,RetWarp.pMedio_dir.y + 2);
          imWarp.Canvas.Ellipse(RetWarp.pMedio_cima.x - 2, RetWarp.pMedio_cima.y - 2,
                                RetWarp.pMedio_cima.x + 2,RetWarp.pMedio_cima.y + 2);
          imWarp.Canvas.Ellipse(RetWarp.pMedio_baixo.x - 2, RetWarp.pMedio_baixo.y - 2,
                                RetWarp.pMedio_baixo.x + 2,RetWarp.pMedio_baixo.y + 2);
          imWarp.Canvas.Pen.Color := clLime;
          imWarp.Canvas.Pen.Width := 1;
        end;
      end;
    end;
  end;
end;

end.
